﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;

namespace BaalaAgni
{
    using Effects;
    public class Building : Entity, EntityObserver
    {
        private Region inside;//This will allow buildings to be explorable
        public Region Inside
        {
            get { return inside; }
            set { inside = value; }
        }

        private bool canEnter;//This is how we know if you can enter the building or not. Spells may destroy houses so be careful :D
        public bool CanEnter
        {
            get { return canEnter; }
            set { canEnter = value; }
        }

        private SpawnEffect spEff;
        public SpawnEffect SpEff
        {
            get { return spEff; }
            set { spEff = value; }
        }

        private Stopwatch spawnTimer;
        public Stopwatch SpawnTimer
        {
            get { return spawnTimer; }
            set { spawnTimer = value; }
        }

        private int spawnCoolDown;
        public int SpawnCoolDown
        {
            get { return spawnCoolDown; }
            set { spawnCoolDown = value; }
        }

        public int maxSpawned = 3;
        public int currentSpawned = 0;

        public Building()
            : base()
        {
            Name = "building";
            TypeName = "building";
            Health = 400;
            IsMoveable = false;
            canEnter = true;
            WrathPoints = 100;
            Faction = 3;
            spawnTimer = new Stopwatch();
            Random rand = new Random();
            spawnCoolDown = rand.Next(6000, 12000);
            //entityCon = new EntityContainer();
        }

        public override string ToString()
        {
            StringBuilder s = new StringBuilder(base.ToString());
            s.AppendLine("canEnter: " + canEnter);
            //s.AppendLine("EntityContainer: " + entityCon.ToString());
            return s.ToString();
        }

        public override void AI()
        {
            if (spawnTimer.ElapsedMilliseconds > spawnCoolDown && currentSpawned<maxSpawned)
            {
                currentSpawned++;
                Entity en = spEff.PerformEffect();
                en.registerObserver(this);
                spawnTimer.Reset();
                spawnTimer.Start();
            }
            else if (!spawnTimer.IsRunning)
            {
                spawnTimer.Start();
            }
        }



        #region EntityObserver Members

        public void update(EntityObservable e, string message)
        {
            if (message == "dead")
            {
                currentSpawned--;
            }
        }

        #endregion
    }
}
