﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using BaalaAgni.Collisions;
using BaalaAgni.Effects;
using System.Diagnostics;

namespace BaalaAgni
{
    using Load;
    public class Character : Entity
    {

        public enum Skills {NORMAL = 0, FIREBALL, FREEZE, THUNDER, BATSWARM, EARTHQUAKE};//to make knowing what skill is being used easier

        public int skillsUsed=0;

        private Skills currentSkill;
        public Skills CurrentSkill
        {
            get { return currentSkill; }
            set { currentSkill = value; }
        }

        private int fear;
        public int Fear
        {
            get { return fear; }
            set { fear = value; }
        }
        private Random rand = new Random();
        public Stopwatch bossSkillTimer = new Stopwatch();//this is to be used by the boss's performSkill method in Skill to allow cooldown.

        /// <summary>
        /// The bulk of character's elements will be set in EntityFactory
        /// </summary>
        public Character()
            : base()
        {
            Health = 50;
            Name = "character";
            TypeName = "character";
            fear = 0;
            MaxHealth = Health;
            currentSkill = Skills.FIREBALL;
            Faction = 2;
        }

        public override void kill()
        {
            
            if (!(this == BaalaAgni.getInstance().Model.PC))
            {
                Music.GetInstance().OnDeath.Play();
            }
            if (this.TypeName == "boss")
            {
                BaalaAgni.getInstance().Model.BossCount--;
                BaalaAgni.getInstance().Model.bossKillCount++;
            }
            base.kill();
                
        }

        public override void AI()
        {
            if (TypeName == "character")//default should just move
            {
                base.AI();
            }

            if (TypeName == "easy")
            {
                Entity player = BaalaAgni.getInstance().Model.PC;
                Vector2 newMovement = new Vector2((float)((Rectangle)player.CollisionMap).Center.X - ((Rectangle)this.CollisionMap).Center.X, (float)((Rectangle)player.CollisionMap).Center.Y - ((Rectangle)this.CollisionMap).Center.Y);
                if (rand.NextDouble() >= .90 && newMovement.Length() < 50)
                {
                    fear++;
                }
                else if (newMovement.Length() > 500 && fear > 0)
                {
                    fear--;
                }
                newMovement.Normalize();
                newMovement.X *= .5f;
                newMovement.Y *= .5f;
                if (fear > 10)
                {
                    newMovement.X *= -1;
                    newMovement.Y *= -1;
                }
                MoveEff.Direction = newMovement;
                MoveEff.performEffect(this);
            }

            if (TypeName == "medium")
            {
            }

            if (TypeName == "hard")
            {
            }

            if (TypeName == "boss")
            {
                Entity player = BaalaAgni.getInstance().Model.PC;
                Vector2 newMovement = new Vector2((float)((Rectangle)player.CollisionMap).Center.X - ((Rectangle)this.CollisionMap).Center.X, (float)((Rectangle)player.CollisionMap).Center.Y - ((Rectangle)this.CollisionMap).Center.Y);
                newMovement.Normalize();
                newMovement.X *= .25f;
                newMovement.Y *= .25f;
                MoveEff.Direction = newMovement;
                MoveEff.performEffect(this);

                Skill.PerformBossSkill(this);
            }

        }
    }
}
