﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using BaalaAgni.Collisions;

namespace BaalaAgni.Effects
{
    public class CollisionEffect : IEffect
    {
        private string effectName;//This will set collisioneffcts apart from other collisioneffects
        public string EffectName
        {
            get { return effectName; }
            set { EffectName = value; }

        }

        private string effectType;//This will set all collisioneffects apart from other types of effects
        public string EffectType
        {
            get { return effectType; }
            set { effectType = value; }
        }

        private int damage;//collisions will generally cause damage but if they cause damage is determined by faction in Entity. (this faction int is still pending)
        public int Damage
        {
            get { return damage; }
            set { damage = value; }
        }


        public CollisionEffect()
        {
            effectName = "collision";
            effectType = "collision";
            damage = 0;
        }

        public CollisionEffect(string name, int pow)
        {
            effectName = name;
            effectType = "collision";
            damage = pow;
        }

        public void performEffect(Entity en)//This is the general collision effect. Damage is dealt. 
        {
            //en.Health -= damage;
        }

        public void performEffect(Entity en, CollisionResult cR)//Only one object of the collision will see this (the one that was moving). This dectects how is was colliding and resets the position so they are instead bording each other without moving the object that was considered to not be moving.
        {
            Entity en1 = (Entity)cR.GotHit;
            Entity en2 = (Entity)cR.Moved;
            if (en1.Faction != en2.Faction)
            {
                en1.Health -= en2.CollisionEff.Damage;
                en2.Health -= en1.CollisionEff.Damage;
            }

            
            //performEffect(en);//make a call to the main effect that will deal the damage
        }

        public override string ToString()
        {
            StringBuilder s = new StringBuilder();
            s.AppendLine("EffectName: " + effectName);
            s.AppendLine("EffectType: " + effectType);
            s.AppendLine("Damage dealt upon collision: " + damage);
            return s.ToString();
        }
    }
}
