﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace BaalaAgni
{
    /// <summary>
    /// IEffect should be implemented to all things that effect an areaor character.
    /// This includes spawn points, stat boosts and possibly graphical effects such as burning buildings.
    /// </summary>
    public interface IEffect
    {
        //string effectName;
        string EffectName
        {
            get;
            set;
        }

        string EffectType
        {
            get;
            set;
        }

        /// <summary>
        /// Performs or applies the designated effect to a specific Entity
        /// </summary>
        /// <param name="performEffect"></param>
        void performEffect(Entity en);

        /// <summary>
        /// Performs or applies the designated effect.
        /// </summary>
        //void performEffect();
    }
}
