﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace BaalaAgni.Effects
{
    public class MoveEffect : IEffect
    {
        private string effectName;
        public string EffectName
        {
            get { return effectName; }
            set { effectName = value; }
        }

        private string effectType;
        public string EffectType
        {
            get { return effectType; }
            set { effectType = value; }

        }

        private Vector2 direction;//How much the Entity will move in the x and y direction
        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public MoveEffect()
        {
            effectName = "move";
            effectType = "move";
            direction = new Vector2();
        }

        public MoveEffect(string name)
        {
            effectName = name;
            effectType = "move";
            direction = new Vector2();
        }

        public MoveEffect(string name, Vector2 vec)
        {
            effectName = name;
            effectType = "move";
            direction = vec;
        }

        public void performEffect(Entity en)//make a new vector with parameters equal to the current position plus its x and y direction and then set this new vector as the Entity's position
        {
            Vector2 newVec = new Vector2(en.SceneNode.Position.X + direction.X, en.SceneNode.Position.Y + direction.Y);
            if (!newVec.Equals(en.SceneNode.Position))
            {
                en.SceneNode.TranslateTo(newVec);
                if (!(direction.X == 0) && !(direction.Y == 0))
                {
                    en.notifyObservers("move");
                }
                if (en == BaalaAgni.getInstance().Model.PC)
                {
                    en.notifyObservers("move");
                }
            }
        }

        public override string ToString()
        {
            StringBuilder s = new StringBuilder();
            s.AppendLine("EffectName: " + effectName);
            s.AppendLine("EffectType: " + effectType);
            s.AppendLine("Direction: " + direction.ToString());
            return s.ToString();
        }

    }
}
