﻿// Jason Green : jhg7420
//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace BaalaAgni.Effects
{
    public class RemoveEffect : IEffect
    {
        private string effectName;
        public string EffectName
        {
            get { return effectName; }
            set { effectName = value; }
        }

        private string effectType;
        public string EffectType
        {
            get { return effectType; }
            set { effectType = value; }
        }

        private List<EntityContainer> removeFrom;//The areas from which the entity will disappear from. This will include World/Region and some collision objects.
        public List<EntityContainer> RemoveFrom
        {
            get { return removeFrom; }
            set { removeFrom = value; }
        }

        public RemoveEffect()
        {
            effectName = "remove";
            effectType = "remove";
            removeFrom = new List<EntityContainer>();
        }

        public RemoveEffect(string name, List<EntityContainer> entityCons)
        {
            effectName = name;
            effectType = "remove";
            removeFrom = entityCons;
        }

        public void performEffect(Entity en)//Go through all the containers and remove this object from them
        {
            foreach (EntityContainer ec in removeFrom)
            {
                ec.removeEntity(en);
            }
        }

        public override string ToString()
        {
            StringBuilder s = new StringBuilder();
            s.AppendLine("EffectName: " + effectName);
            s.AppendLine("EffectType: " + effectType);
            /*s.AppendLine("Removes Entities from: ");
            foreach (EntityContainer enCon in removeFrom)
            {
                s.AppendLine(enCon.ToString());
            }*/
            return s.ToString();
        }
    }
}
