﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace BaalaAgni.Effects
{
    public class SpawnEffect : IEffect
    {
        private string effectName;
        public string EffectName
        {
            get { return effectName; }
            set { effectName = value; }
        }

        private string effectType;
        public string EffectType
        {
            get { return effectType; }
            set { effectType = value; }

        }

        private Vector2 position;//Position at which the new Entities will appear
        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }

        private EntityFactory factory;
        public EntityFactory Factory
        {
            get
            {
                return factory;
            }
            set
            {
                factory = value;
            }
        }

        private EntityContainer entityCon;
        public EntityContainer EntityCon
        {
            get { return entityCon; }
            set { entityCon = value; }
        }

        public SpawnEffect()
        {
            effectName = "spawn";
            effectType = "spawn";
            factory = new RandomEntityFactory();
            position = new Vector2();
        }

        public SpawnEffect(string name, /*Factory fac, */Vector2 vec)
        {
            effectName = name;
            effectType = "spawn";
            factory = new RandomEntityFactory();
            position = vec;
        }

        public void performEffect(Entity en)
        {
            Entity ent = factory.makeEntity(this.position, new Vector2(0, 1));
            

        }

        public Entity PerformEffect()
        {
            return factory.makeEntity(this.position, new Vector2(0, 1));
        }

        public override string ToString()
        {
            StringBuilder s = new StringBuilder();
            s.AppendLine("EffectName: " + effectName);
            s.AppendLine("EffectType: " + effectType);
            //s.AppendLine("SpawnType: " + factory.spawnType);
            s.AppendLine("Spawn at: " + position.ToString());
            //s.AppendLine("Add to: " + entityCon.ToString());
            return s.ToString();
        }
    }
}
