﻿//Matt Monasch: mpm1052@rit.edu
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

namespace BaalaAgni
{
    using Effects;
    using Collisions;

    public class Projectile : Entity
    {
        private Entity shotFrom;//this is what the projectile was shot from. This will be null in most cases since it was something thrown in at the last moment to make boss skills work
        public Entity ShotFrom//the reason this is an entity is because we may at some point decide to have Buildings be Sentry Towers and shoot arrows from them.
        {
            get { return shotFrom; }
            set { shotFrom = value; }
        }

        public Projectile()
            : base()
        {
            Health = 1;
            Name = "projectile";
            TypeName = "projectile";
            shotFrom = null;
            WrathPoints = 0;
        }

        public override void Collide(CollisionResult cr)
        {
            //soundEff.performEffect(null);
            
            if (Health != -1337)
            {
                Music.GetInstance().SkillSounds[(int)BaalaAgni.getInstance().Model.PC.CurrentSkill].Play();
            }
            base.Collide(cr);
            this.Health = -1337;
            this.CollisionEff.Damage = 0;
        }

        public override void AI()
        {
            switch (this.Name)
            {
                case "fireball":
                    base.AI();
                    //Console.WriteLine("FIRE!");
                    break;
                case "ice":
                    Health -= .01;
                    break;
                case "thundercloud":
                    Character user = (Character)this.shotFrom;
                    double angle = Math.Atan(((double)(((Rectangle)this.CollisionMap).Center.Y - ((Rectangle)user.CollisionMap).Center.Y)) / ((double)(((Rectangle)this.CollisionMap).Center.X - ((Rectangle)user.CollisionMap).Center.X)));//get the angle in reference to the Warlock
                    angle += Math.PI / 33;//increase the angle so that it advances its position around the Warlock
                    //Console.WriteLine(angle * 180 / Math.PI);
                    if (((Rectangle)this.CollisionMap).Center.X - ((Rectangle)user.CollisionMap).Center.X <= 0)
                    {
                        angle = angle + Math.PI;

                    }
                    this.SceneNode.Position = new Vector2((float)((Math.Cos(angle) * 200) + ((Rectangle)user.CollisionMap).Center.X - ((Rectangle)this.CollisionMap).Width/2), (float)((Math.Sin(angle) * 200) + ((Rectangle)user.CollisionMap).Center.Y - ((Rectangle)this.CollisionMap).Height/2));//get the new Positions dictated by the new angle
                    this.Health -= .01;
                    break;
                case "bats":
                    Random rand = new Random();
                    double dirFactor = rand.NextDouble();//get a random number between 0 and 1
                    double dirInRads = 2 * Math.PI * dirFactor;//multiply that number by 2Pi to get a random direction
                    this.MoveEff.Direction = new Vector2((float)Math.Cos(dirInRads) * 25, (float)Math.Sin(dirInRads) * 25);//set the new direction to the moveeffect
                    base.AI();//make a call to the base to make it move
                    break;
                case "earthquake":
                    BaalaAgni.getInstance().View.Camera.shake();
                    foreach (Entity e in BaalaAgni.getInstance().Model.Region.Entities)
                    {
                        if (!(BaalaAgni.getInstance().Model.PC == e))
                        {
                            e.Health -= this.CollisionEff.Damage;
                        }

                    }
                    this.Health = 0;
                    break;
            }
        }
    }
}
